/*
   Copyright (C) 2001-2003 Thomas Capricelli <orzel@freehackers.org>
*/

#ifndef OPALE_VIEW
#define OPALE_VIEW

/* Qt */
#include <qptrdict.h>
#include <qvaluelist.h>
/* KDE */
#include <kaction.h>
/* KOffice */
#include <koView.h>
/* Opale */
#include "opale_record.h"


class QPaintEvent;
class QLabel;
class OpalePart;
class QListViewItem;
class QListView;
class KListView;
class KAction;


class OpaleView : public KoView
{
    Q_OBJECT
public:
    OpaleView( OpalePart* part, QWidget* parent = 0, const char* name = 0 );

	OpalePart * opalepart(void) { return ((OpalePart*)koDocument()); }
protected slots:
    void delete_record(void);
    void repeat_record(void);
    void new_record(void);
    void new_pattern(void);
    void new_record_from_pattern(int);
    void get_graph(void);
    void editRecord(QListViewItem *);
    void editFileOptions(void);
    void spacePressedRecord(QListViewItem *);
    void newPatterns(QStringList);

signals:
    void updateGraphs(void);

protected:
    virtual void updateReadWrite( bool readwrite );
    void	fillList(void);
    QString	fillLabel(amount_t amount, bool exact=false);

private:
	KListAction	*m_patternaction;
	KListView	*list;
	QLabel		*l_total, *l_utt, *l_uttsafe, *l_checked;
	QPtrDict<OpaleRecord>	*current_dict;
	Total		total;
};

#endif
